// ManageKey.h: CManageKey NX̃C^[tFCX
//
// Copyright (C) 2006 Kazuyoshi Kakihara
//
// This file is part of JanusLeaf.
//
// JanusLeaf is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MANAGEKEY_H__6A839B0C_296C_4944_B906_9C1863BBFDC4__INCLUDED_)
#define AFX_MANAGEKEY_H__6A839B0C_296C_4944_B906_9C1863BBFDC4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CManageKey : public CDialogImpl<CManageKey>  
{
  CGpgParam *pm_gpg;
public:
  enum { IDD = IDD_KEYMANAGER };
  CListViewCtrl m_list;

  // bZ[W}bv
  BEGIN_MSG_MAP_EX(CGenkeyDlg)
    MSG_WM_INITDIALOG(OnInitDialog)
    COMMAND_ID_HANDLER_EX(IDOK, OnOK)
    COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
    COMMAND_ID_HANDLER_EX(ID_KEYMANAGER_IMPORT, OnImport)
    COMMAND_ID_HANDLER_EX(ID_KEYMANAGER_EXPORT, OnExport)
    COMMAND_ID_HANDLER_EX(ID_KEYMANAGER_DELETE, OnDelete)
  END_MSG_MAP()

  HRESULT loadKeys(VOID) {
    HRESULT hr = S_OK;
    std::vector<std::string> keylist;

    m_list.DeleteAllItems();
    gpg g(pm_gpg->gpgexe.c_str(), pm_gpg->homedir.c_str(), pm_gpg->secring, pm_gpg->pubring);
    g.listkey(FALSE, keylist, NULL, NULL);
    int il = 0, icol = 0;
    for (std::vector<std::string>::iterator itr = keylist.begin(); itr != keylist.end(); ++itr) {
      icol = (*itr).find(':');
      std::string struid = (*itr).substr(0, icol);
      std::string strfpr = (*itr).substr(icol + 1);
      if ((il = m_list.InsertItem(il, struid.c_str())) == -1) {
        hr = HRESULT_FROM_WIN32(::GetLastError());
        DEBUGOUT(hr);
        return hr;
      }
      // fingerprint4Ƃɋ؂
      std::string strfprv;
      int ic = 0;
      for (std::string::const_iterator itr = strfpr.begin(); itr != strfpr.end(); ++itr) {
        if ((ic != 0) && (ic % 4 == 0)) {
          strfprv.append(" ");
        }
        strfprv.append(&(*itr), 1);
        ++ic;
      }
      if (!m_list.SetItemText(il, 1, strfprv.c_str())) {
        hr = HRESULT_FROM_WIN32(::GetLastError());
        DEBUGOUT(hr);
        return hr;
      }
    }
    return S_OK;
  }

  LRESULT OnInitDialog(HWND hWnd, LPARAM lParam) {
    CenterWindow();
    pm_gpg = reinterpret_cast<CGpgParam *>(lParam);
    m_list = GetDlgItem(IDC_KEYMANAGER_LIST);
    m_list.SetExtendedListViewStyle(LVS_EX_FULLROWSELECT);
    m_list.InsertColumn(0, "Name", LVCFMT_LEFT, 200, 0);
    m_list.InsertColumn(1, "Fingerprint", LVCFMT_LEFT, 400, 0);

    loadKeys();
    return 0;
  }

  void OnOK(UINT uNotifyCode, int nID, HWND hWndCtl) {
    EndDialog(IDOK);
  }

  void OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl) {
    EndDialog(IDCANCEL);
  }

  void OnImport(UINT uNotifyCode, int nID, HWND hWndCtl) {
    HRESULT hr = S_OK;
    CFileDialog dlg(TRUE, _T("gpg"), NULL, OFN_HIDEREADONLY | OFN_CREATEPROMPT,
      _T("J t@C (*.gpg)\0*.gpg\0ׂẴt@C (*.*)\0*.*\0\0"));
    if (dlg.DoModal() == IDOK) {
//      gpg g(pm_gpg->gpgexe.c_str(), pm_gpg->homedir.c_str(), pm_gpg->secring, pm_gpg->pubring);

      // YŔ閧ɑ̌܂̂h
      std::vector<std::string> dummyring;
      dummyring.push_back("nul");
      gpg g(pm_gpg->gpgexe.c_str(), pm_gpg->homedir.c_str(), dummyring, pm_gpg->pubring);

      if (FAILED(hr = g.importkey(dlg.m_szFileName, NULL))) {
        DEBUGOUT(hr);
        return;
      }
      loadKeys();
    }
  }

  void OnExport(UINT iNotifyCode, int nID, HWND hWndCtl) {
    HRESULT hr = S_OK;
    int ii = 0;

    ii = m_list.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
    if (ii == -1) return;
    CHAR szuid[MAX_PATH + 1], szfpr[MAX_PATH + 1];
    m_list.GetItemText(ii, 0, szuid, MAX_PATH);
    m_list.GetItemText(ii, 1, szfpr, MAX_PATH);
    CFileDialog dlg(FALSE, _T("gpg"), _T("Untitled"), OFN_OVERWRITEPROMPT,
      _T("J t@C (*.gpg)\0*.gpg\0ׂẴt@C (*.*)\0*.*\0\0"));
    if(dlg.DoModal() == IDOK) {
      LPCSTR p = szfpr;
      LPSTR p1 = szfpr;
      while (*p) {
        if (*p == ' ') ++p;
        *p1 = *p;
        ++p1;
        ++p;
      }
      *p1 = '\0';
      gpg g(pm_gpg->gpgexe.c_str(), pm_gpg->homedir.c_str(), pm_gpg->secring, pm_gpg->pubring);
      if (FAILED(hr = g.exportkey(szfpr, dlg.m_szFileName, NULL))) {
        DEBUGOUT(hr);
        return;
      }
    }
  }

  void OnDelete(UINT iNotifyCode, int nID, HWND hWndCtl) {
    HRESULT hr = S_OK;
    int ii = 0;
    ii = m_list.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
    if (ii == -1) return;
    CHAR szuid[MAX_PATH + 1], szfpr[MAX_PATH + 1];
    m_list.GetItemText(ii, 0, szuid, MAX_PATH);
    m_list.GetItemText(ii, 1, szfpr, MAX_PATH);
    LPCSTR p = szfpr;
    LPSTR p1 = szfpr;
    while (*p) {
      if (*p == ' ') ++p;
      *p1 = *p;
      ++p1;
      ++p;
    }
    *p1 = '\0';
    gpg g(pm_gpg->gpgexe.c_str(), pm_gpg->homedir.c_str(), pm_gpg->secring, pm_gpg->pubring);
    if (FAILED(hr = g.deletekey(szfpr, NULL))) {
      DEBUGOUT(hr);
    }
    loadKeys();
  }
};

#endif // !defined(AFX_MANAGEKEY_H__6A839B0C_296C_4944_B906_9C1863BBFDC4__INCLUDED_)
