// WebExternal.h: CWebExternal NX̃C^[tFCX
//
// Copyright (C) 2006 Kazuyoshi Kakihara
//
// This file is part of JanusLeaf.
//
// JanusLeaf is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WEBEXTERNAL_H__9D2F9D37_1D59_4FF1_8B37_42CF8E84CFFC__INCLUDED_)
#define AFX_WEBEXTERNAL_H__9D2F9D37_1D59_4FF1_8B37_42CF8E84CFFC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
class CWebExternal : public IDispatch  
{
private:
public:
  CWebExternal() { };
  virtual ~CWebExternal() { };

  HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid,
											 void __RPC_FAR *__RPC_FAR *ppvObject) {
		if (riid == IID_IUnknown || riid == IID_IDispatch) {
			if (ppvObject == NULL)
				return E_POINTER;
			*ppvObject = this;
			AddRef();
			return S_OK;
		} else {
			*ppvObject = 0;
			return E_NOINTERFACE;
		}
	}

	ULONG STDMETHODCALLTYPE AddRef() {
		return 1;
	}

	ULONG STDMETHODCALLTYPE Release() {
		return 1;
	}

  //----------------------------------------------------------------------------
  virtual void saveLeaf(void) = 0;
  virtual void attachFile(VARIANT* pvarResult) = 0;
  virtual void detachFile(UINT uid, VARIANT* pvarResult) = 0;
  virtual void listFile(VARIANT* pvarResult) = 0;
  virtual void extractFile(UINT uid) = 0;
  virtual void saveForm(VARIANT var) = 0;

	//----------------------------------------------------------------------------
	// IDispatch 

	STDMETHOD(GetTypeInfoCount)(UINT* pctinfo) {
		return E_NOTIMPL;
	}

	STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo** pptinfo) {
		return E_NOTIMPL;
	}

	enum {
		NONE = 0,
		SAVELEAF = 1,
    ATTACHFILE,
    DETACHFILE,
    LISTFILE,
    EXTRACTFILE,
    SAVEFORM
	};

  /**
	 * \bhID̑ΉƂ郁\bh
	 * regszNames Ƀ\bh̔z񂪂̂ŁA
	 * rgdispid ɑΉ dispid ԂĂ
	 */
	STDMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames,
							 LCID lcid, DISPID* rgdispid) {
		UINT i;
		for (i=0; i<cNames; i++) {
			if (wcscmp(rgszNames[i], OLESTR("saveLeaf")) == 0) {
				rgdispid[i] = SAVELEAF;
      } else if (wcscmp(rgszNames[i], OLESTR("attachFile")) == 0) {
        rgdispid[i] = ATTACHFILE;
      } else if (wcscmp(rgszNames[i], OLESTR("detachFile")) == 0) {
        rgdispid[i] = DETACHFILE;
      } else if (wcscmp(rgszNames[i], OLESTR("listFile")) == 0) {
        rgdispid[i] = LISTFILE;
      } else if (wcscmp(rgszNames[i], OLESTR("extractFile")) == 0) {
        rgdispid[i] = EXTRACTFILE;
      } else if (wcscmp(rgszNames[i], OLESTR("saveForm")) == 0) {
        rgdispid[i] = SAVEFORM;
			} else {
				rgdispid[i] = NONE;
			}
		}
		return S_OK;
	}

	/**
	 * \bhs
	 * dispidMember Ń\bhw肳B pdispparams  VARIANT ̔z
	 * ̌`ł킽̂łg
	 */
	STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid,
		LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult,
		EXCEPINFO* pexcepinfo, UINT* puArgErr) {
		switch (dispidMember) {
		case SAVELEAF:
			{
        saveLeaf();
			}
			break;
    case ATTACHFILE:
      {
        attachFile(pvarResult);
      }
      break;
    case DETACHFILE:
      {
        UINT uid = 0;
        if (pdispparams->rgvarg[0].vt == VT_BSTR) {
          uid = _wtoi(pdispparams->rgvarg[0].bstrVal);
        } else if (pdispparams->rgvarg[0].vt == VT_I2) {
          uid = static_cast<UINT>(pdispparams->rgvarg[0].iVal);
        } else if (pdispparams->rgvarg[0].vt == VT_I4) {
          uid = static_cast<UINT>(pdispparams->rgvarg[0].lVal);
        } else if (pdispparams->rgvarg[0].vt == VT_UI1) {
          uid = static_cast<UINT>(pdispparams->rgvarg[0].bVal);
        }
        detachFile(uid, pvarResult);
      }
      break;
    case LISTFILE:
      {
        listFile(pvarResult);
      }
      break;
    case EXTRACTFILE:
      {
        UINT uid = 0;
        if (pdispparams->rgvarg[0].vt == VT_BSTR) {
          uid = _wtoi(pdispparams->rgvarg[0].bstrVal);
        } else if (pdispparams->rgvarg[0].vt == VT_I2) {
          uid = static_cast<UINT>(pdispparams->rgvarg[0].iVal);
        } else if (pdispparams->rgvarg[0].vt == VT_I4) {
          uid = static_cast<UINT>(pdispparams->rgvarg[0].lVal);
        } else if (pdispparams->rgvarg[0].vt == VT_UI1) {
          uid = static_cast<UINT>(pdispparams->rgvarg[0].bVal);
        }
        extractFile(uid);
      }
      break;
    case SAVEFORM:
      {
        if (pdispparams->rgvarg[0].vt == VT_BSTR) {
          saveForm(pdispparams->rgvarg[0]);
        }
      }
      break;
		default:
			return E_NOTIMPL;
		}
		return S_OK;
	}
};

#endif // !defined(AFX_WEBEXTERNAL_H__9D2F9D37_1D59_4FF1_8B37_42CF8E84CFFC__INCLUDED_)
