// gpg.h: gpg NX̃C^[tFCX
//
// Copyright (C) 2006 Kazuyoshi Kakihara
//
// This file is part of JanusLeaf.
//
// JanusLeaf is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GPG_H__B4CC4F83_4FBE_4B34_B9D2_B48CCD9CDE45__INCLUDED_)
#define AFX_GPG_H__B4CC4F83_4FBE_4B34_B9D2_B48CCD9CDE45__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

static std::vector<std::string> nullring;

class gpg : public ioutil
{
protected:
  HANDLE hProcess;
  HANDLE hThread;
  HANDLE hStdIn;
  HANDLE hStdOut;
  HANDLE hStdErr;
  std::string gpgexe;
  std::string confdir;
  std::vector<std::string> secring;
  std::vector<std::string> pubring;
public:
  /*! RXgN^
   *  @param "gpg.exe"̃pX
   *  @param gpg.exe--homedirIvṼpX
   *  @param 閧O
   *  @param JO
   */
	gpg(LPCSTR gpgexe = NULL, LPCSTR confdir = NULL, std::vector<std::string> &secring = nullring, std::vector<std::string> &pubring = nullring);
	virtual ~gpg();

  static DWORD WINAPI procUI(LPVOID lpparam);
  HRESULT setStdErr(HANDLE hStdErr);
  HRESULT execute(std::string &cmdline, LPCSTR passphrase = NULL, HANDLE hStautsC = INVALID_HANDLE_VALUE, HANDLE hCommandC = INVALID_HANDLE_VALUE);
  HRESULT close(LPDWORD lpdwExitCode = NULL);

  HRESULT validateName(LPCSTR name);
  HRESULT validateEMail(LPCSTR email);
  HRESULT validateComment(LPCSTR comment);

  /* encrypt */
  HRESULT encryptfile(std::vector<std::string> &recipients, LPCSTR srcfile, LPCSTR dstfile, BOOL bSign, LPCSTR passphrase, LPDWORD lpdwExitCode = NULL);
  HRESULT encryptfile_sym(LPCSTR srcfile, LPCSTR dstfile, BOOL bSign, LPCSTR passphrase, LPCSTR passphrase_sym, LPDWORD lpdwExitCode = NULL);
  HRESULT encrypt_open(std::vector<std::string> &recipients, HANDLE hStdIn, HANDLE hStdOut, BOOL bSign, LPCSTR passphrase, HANDLE hStatusC = INVALID_HANDLE_VALUE, HANDLE hCommandC = INVALID_HANDLE_VALUE);
  HRESULT encrypt_sym_open(HANDLE hStdIn, HANDLE hStdOut, BOOL bSign, LPCSTR passphrase, HANDLE hStatusC = INVALID_HANDLE_VALUE, HANDLE hCommandC = INVALID_HANDLE_VALUE);

  /* decrypt */
  HRESULT decryptfile(LPCSTR srcfile, LPCSTR dstfile, BOOL bVerify, LPCSTR passphrase, LPDWORD lpdwExitCode = NULL);
  HRESULT decrypt_open(HANDLE hStdIn, HANDLE hStdOut, BOOL bVerify, LPCSTR passphrase, HANDLE hStatusC = INVALID_HANDLE_VALUE, HANDLE hCommandC = INVALID_HANDLE_VALUE);

  /* sign */
  HRESULT sign_detach(LPCSTR srcfile, LPCSTR signfile, LPCSTR passphrase);

  /* verify */
  HRESULT verify(LPCSTR srcfile, LPCSTR signfile, LPCSTR passphrase);

  /* keyring management */

  /*! GnuPǦyA𐶐(㏑mF̃G[`FbN͍ςł邱ƂO)
   *  @param 閧t@C
   *  @param Jt@C
   *  @param [U[(UTF-8)
   *  @param e-mailAhX(`FbN)
   *  @param Rg(UTF-8) 
   *  @param pXt[Y
   */
  HRESULT genkey(LPCSTR secring, LPCSTR pubring, LPCSTR name = NULL, LPCSTR email = NULL, LPCSTR comment = NULL, LPCSTR passphrase = NULL, HANDLE hStatusC = INVALID_HANDLE_VALUE, HANDLE hCommandC = INVALID_HANDLE_VALUE);
  HRESULT listkey(BOOL bSec, std::vector<std::string> &keyid /* fingerprint:Name(comment)<email>*/, LPCSTR name, LPCSTR passphrase);
  HRESULT importkey(LPCSTR keyfile, LPCSTR passphrase);
  HRESULT exportkey(LPCSTR keyid, LPCSTR keyfile, LPCSTR passphrase);
  HRESULT deletekey(LPCSTR keyid, LPCSTR passphrase);
};

#endif // !defined(AFX_GPG_H__B4CC4F83_4FBE_4B34_B9D2_B48CCD9CDE45__INCLUDED_)
