// ioutil.h: ioutil NX̃C^[tFCX
//
// Copyright (C) 2006 Kazuyoshi Kakihara
//
// This file is part of JanusLeaf.
//
// JanusLeaf is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IOUTIL_H__AD5E827D_4E45_46D2_B051_EF78C956C388__INCLUDED_)
#define AFX_IOUTIL_H__AD5E827D_4E45_46D2_B051_EF78C956C388__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class ioutil  
{
protected:
  static HRESULT write(HANDLE h, LPCSTR lpcszLine)
  {
    HRESULT hr = S_OK;
    DWORD dwWrite = ::lstrlen(lpcszLine), dwWritten, dwPos = 0;
    while (TRUE) {
      if (!::WriteFile(h, lpcszLine + dwPos, dwWrite - dwPos, &dwWritten, NULL)) {
        hr = HRESULT_FROM_WIN32(::GetLastError());
        return hr;
      }
      dwPos += dwWritten;
      if (dwPos == dwWrite) break;
    }
    return hr;
  }

  static HRESULT write(HANDLE h, LPVOID buff, DWORD dwWrite)
  {
    HRESULT hr = S_OK;
    DWORD dwWritten, dwPos = 0;
    while (TRUE) {
      if (!::WriteFile(h, reinterpret_cast<LPBYTE>(buff) + dwPos, dwWrite - dwPos, &dwWritten, NULL)) {
        hr = HRESULT_FROM_WIN32(::GetLastError());
        return hr;
      }
      dwPos += dwWritten;
      if (dwPos == dwWrite) break;
    }
    return hr;
  }

  static HRESULT read(HANDLE hRead, std::string &str, LPDWORD lpdwRead)
  {
    HRESULT hr = S_OK;
    CHAR c;
    DWORD dwRead1;
    str = "";
    DWORD len = 0;
    while (TRUE) {
      if (!::ReadFile(hRead, &c, 1, &dwRead1, NULL)) {
        DWORD dwErr = ::GetLastError();
        if (dwErr == ERROR_BROKEN_PIPE) {
          hr = S_OK;
          break;
        }
        hr = HRESULT_FROM_WIN32(dwErr);
        break;
      }
      if (dwRead1 == 0) break;
      ++len;
      if (c == '\n') {
        break;
      } else if (c == '\r') {
        ::ReadFile(hRead, &c, 1, &dwRead1, NULL); // \r̎\nƌ߂œǂݔ΂
        ++len;
        break;
      }
      str.append(&c, 1);
    }
    if (lpdwRead) *lpdwRead = len;
    return hr;
  }

  static HRESULT utf82sjis(LPCSTR psrc, std::string &str)
  {
    USES_CONVERSION;
    HRESULT hr = S_OK;
    DWORD dwLen = ::lstrlenA(psrc) + 1;
    LPWSTR pwcs = (LPWSTR)_alloca(dwLen * 2);
    ::MultiByteToWideChar(CP_UTF8, 0, psrc, -1, pwcs, dwLen * 2);
    LPSTR psjis = W2A(pwcs);
    str = psjis;
    return hr;
  }

  static HRESULT sjis2utf8(LPCSTR psrc, std::string &str)
  {
    USES_CONVERSION;
    HRESULT hr = S_OK;
    LPWSTR pwcs = A2W(psrc);
    DWORD dwLen = (::lstrlenW(pwcs) + 1) * 2;
    LPSTR putf8 = (LPSTR)_alloca(dwLen);
    WideCharToMultiByte(CP_UTF8, 0, pwcs, -1, putf8, dwLen, NULL, NULL);
    str = putf8;
    return hr;
  }

  static DWORD base64encode(LPCBYTE lpcByte, int len, LPBYTE buffencoded) {
    unsigned char b64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    LPCBYTE p = lpcByte;

    _ASSERT(len > 0);

    buffencoded[0] = b64[p[0] >> 2];
    if (len > 1) {
      buffencoded[1] = b64[((p[0] & 0x03) << 4) | (p[1] >> 4)];
      if (len > 2) {
        buffencoded[2] = b64[((p[1] & 0x0f) << 2) | (p[2] >> 6)];
        buffencoded[3] = b64[p[2] & 0x3f];
      } else {
        buffencoded[2] = b64[((p[1] & 0x0f) << 2)];
        buffencoded[3] = '=';
      }
    } else {
      buffencoded[1] = b64[((p[0] & 0x03) << 4)];
      buffencoded[2] = '=';
      buffencoded[3] = '=';
    }
    buffencoded[4] = '\0';
    // GR[h͕̕K4oCgPʂɂȂ
    return 4;
  }

  static DWORD base64decode(LPCSTR lpcSrc, LPBYTE lpDst) {
    unsigned char b64[129] = {
      0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
      0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
      0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
      0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
      0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
      0xff, 0xff, 0xff,   62, 0xff, 0xff, 0xff,   63,
        52,   53,   54,   55,   56,   57,   58,   59,
        60,   61, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
      0xff,    0,    1,    2,    3,    4,    5,    6,
         7,    8,    9,   10,   11,   12,   13,   14,
        15,   16,   17,   18,   19,   20,   21,   22,
        23,   24,   25, 0xff, 0xff, 0xff, 0xff, 0xff,
      0xff,   26,   27,   28,   29,   30,   31,   32,
        33,   34,   35,   36,   37,   38,   39,   40,
        41,   42,   43,   44,   45,   46,   47,   48,
        49,   50,   51, 0xff, 0xff, 0xff, 0xff, 0xff
        };
    DWORD dwLen = 0;
    LPCSTR p = lpcSrc;

    lpDst[dwLen] = ((b64[lpcSrc[0]] << 2) | (b64[lpcSrc[1]] >> 4));
    ++dwLen;
    if (lpcSrc[2] != '=') {
      lpDst[dwLen] = ((b64[lpcSrc[1]] << 4) | (b64[lpcSrc[2]] >> 2));
      ++dwLen;
      if (lpcSrc[3] != '=') {
        lpDst[dwLen] = ((b64[lpcSrc[2]] << 6) | (b64[lpcSrc[3]]));
        ++dwLen;
      }
    }
    lpDst[dwLen] = '\0';
    return dwLen;
  }

  static HRESULT createReadPipe(LPHANDLE phRead, LPHANDLE phWrite)
  {
    HRESULT hr = S_OK;
    *phWrite = INVALID_HANDLE_VALUE;
    *phRead = INVALID_HANDLE_VALUE;
    HANDLE hProcess = ::GetCurrentProcess();
    HANDLE h = INVALID_HANDLE_VALUE;

    SECURITY_ATTRIBUTES sa;
    ZeroMemory(&sa, sizeof(SECURITY_ATTRIBUTES));
    sa.nLength = sizeof(SECURITY_ATTRIBUTES);
    sa.bInheritHandle = TRUE;
    sa.lpSecurityDescriptor = NULL;

    if (!::CreatePipe(&h, phWrite, &sa, 0)) {
      hr = HRESULT_FROM_WIN32(::GetLastError());
      goto finish_func;
    }
    if (!::DuplicateHandle(hProcess, h, hProcess, phRead, 0, FALSE, DUPLICATE_SAME_ACCESS)) {
      hr = HRESULT_FROM_WIN32(::GetLastError());
      ::CloseHandle(*phWrite);
      *phWrite = INVALID_HANDLE_VALUE;
      goto finish_func;
    }
  finish_func:
    if (h != INVALID_HANDLE_VALUE) ::CloseHandle(h);
    return hr;
  }

  static HRESULT createWritePipe(LPHANDLE phWrite, LPHANDLE phRead)
  {
    HRESULT hr = S_OK;
    *phWrite = INVALID_HANDLE_VALUE;
    *phRead = INVALID_HANDLE_VALUE;
    HANDLE hProcess = ::GetCurrentProcess();
    HANDLE h = INVALID_HANDLE_VALUE;

    SECURITY_ATTRIBUTES sa;
    ZeroMemory(&sa, sizeof(SECURITY_ATTRIBUTES));
    sa.nLength = sizeof(SECURITY_ATTRIBUTES);
    sa.bInheritHandle = TRUE;
    sa.lpSecurityDescriptor = NULL;

    if (!::CreatePipe(phRead, &h, &sa, 0)) {
      hr = HRESULT_FROM_WIN32(::GetLastError());
      goto finish_func;
    }
    if (!::DuplicateHandle(hProcess, h, hProcess, phWrite, 0, FALSE, DUPLICATE_SAME_ACCESS)) {
      hr = HRESULT_FROM_WIN32(::GetLastError());
      ::CloseHandle(*phRead);
      *phRead = INVALID_HANDLE_VALUE;
      goto finish_func;
    }
  finish_func:
    if (h != INVALID_HANDLE_VALUE) ::CloseHandle(h);
    return hr;
  }

  public:
    ioutil() { };
    virtual ~ioutil() { };
  };

#endif // !defined(AFX_IOUTIL_H__AD5E827D_4E45_46D2_B051_EF78C956C388__INCLUDED_)
